<?php /* Template Name: Home */ 

get_header(); 

?>

<section id="topsection">
    <div class="container">
        <h2><?php the_field('title_home') ?></h2>
        <p><?php the_field('subtitle_home') ?></p>
        <div id="midtop">
            <div style="background:url(<?php the_field('image_left_home') ?>)">
                <div class="intern-content">
                    <div class="titles">
                        <h3>Business</h3>
                        <p>immigration</p>
                    </div>
                    <div class="menucito">
                        <?php
    wp_nav_menu( array(
        'menu' => 'menu-business-inmigration'
    ) );
                        ?>
                    </div>
                </div>
            </div>
            <div style="background:url(<?php the_field('image_right_home') ?>)">
                <div class="intern-content">
                    <div class="titles">
                        <h3>Family</h3>
                        <p>immigration</p>
                    </div>
                    <div class="menucito">
                        <?php
    wp_nav_menu( array(
        'menu' => 'menu-family-inmigration'
    ) );
                        ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

<section id="secondsection">
    <div class="container">
        <h3 class="h3"><?php the_field('title_section_ocb','option') ?></h3>
        <h5 class="subtitle border-bottom"><?php the_field('subtitle_section_ocb','option') ?></h5>
        <ul id="locations">
            <?php

    if( have_rows('offices_ocb','option') ):

            while ( have_rows('offices_ocb','option') ) : the_row();

            ?>

            <li>
                <div>
                    <a href="<?php the_sub_field('link'); ?>"></a>
                    <figure style="background:url(<?php the_sub_field('background'); ?>)"></figure>
                    <span><?php the_sub_field('text'); ?></span>
                </div>
            </li>

            <?php

            endwhile;

            else :

            // no rows found

            endif;

            ?>
        </ul>
        <?php the_field('content_ocb','option') ?>
    </div>
</section>


<section class="iconsection">
    <div class="container">
        <h3 class="h3 white border-bottom"><?php the_field('title_is') ?></h3>
        <ul class="icons-description">
            
            <?php

            if( have_rows('list_icons_h') ):

            while ( have_rows('list_icons_h') ) : the_row();

            ?>
            
            <li>
                <figure>
                    <img src="<?php the_sub_field('icon_is'); ?>">
                </figure>
                <p><?php the_sub_field('text_is'); ?></p>
            </li>
            
            <?php

            endwhile;

            else :

            // no rows found

            endif;

            ?>

        </ul>
    </div>
</section>

<section class="videosection">
    <div class="container">
        <h3 class="h3"><?php the_field('title_vid') ?></h3>
        <h5 class="subtitle border-bottom"><?php the_field('subtitle_vid') ?></h5>
        <div class="sectvideo">
            <div>
                <video class="videozm video-full" preload="auto" poster="<?php the_field('image_preview_video') ?>">
                    <source src="<?php the_field('video') ?>" type="video/mp4">
                    Your browser does not support the video tag.
                </video>
                <div class="playpause">
                    <i class="fas fa-play"></i>
                </div>
                <h4 class="subtitle"><?php the_field('title_video_vid') ?></h4>
            </div>
            <div>
                <?php the_field('text_video') ?>
            </div>
        </div>
    </div>
</section>

<section class="sectionposts">
    <div class="container">
        <h3 class="h3">Stay Updated</h3>
        <h5 class="subtitle border-bottom">Read the latest from our blog</h5>
        <div class="blockposts">
            <?php 
            query_posts(array( 
                'post_type' => 'post',
                'posts_per_page' => '3'
            )); 
            ?>

            <?php while (have_posts()) : the_post(); ?>

            <div>
                <div class="item-post">
                    <h3><a href="<?php the_permalink() ?>"><?php the_title(); ?></a></h3>
                    <span class="fecha"><span><?php echo get_the_date(); ?></span></span>
                    <?php the_excerpt() ?>
                    <a class="permalink" href="<?php the_permalink() ?>">Read More</a>
                </div>
            </div>

            <?php endwhile;?>
            <?php wp_reset_query(); ?> 
        </div>
    </div>
</section>

<section class="contacthome">
    <div class="container">
        <h3 class="h3 border-bottom"><?php the_field('title_section_fc','option') ?></h3>
        <div class="blockcontacth">
            <div>
                <?php the_field('content_left_fc','option') ?>
            </div>
            <div> 
                <?php echo do_shortcode('[contact-form-7 id="64" title="Contact form"]'); ?>
            </div>
        </div>
    </div>
</section>

<?php get_footer(); ?>

